package com.jiuqi.mde;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.jiuqi.mde.OrderDimension;
import com.jiuqi.util.JqLib;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class MDEDimension {
  public String name;
  
  public String title;
  
  public String fieldName;
  
  public boolean isString = true;
  
  public Object object;
  
  public String order = "";
  
  public static final String ORDER_NAME = "顺序号";
  
  public Object getMinValue() {
    if (this.isString)
      return MIN_STR_DIM_VALUE; 
    return MIN_INT_DIM_VALUE;
  }
  
  public Object getMaxValue() {
    if (this.isString)
      return MAX_STR_DIM_VALUE; 
    return MAX_INT_DIM_VALUE;
  }
  
  public Object cloneValue(Object dimValue) {
    return dimValue;
  }
  
  public Object parseValue(String strValue) {
    if (strValue == null || strValue.length() == 0)
      return null; 
    if (this.isString)
      return strValue; 
    return new Integer((int)Long.parseLong(strValue, 16));
  }
  
  public String formatValue(Object dimValue) {
    if (this.isString)
      return (String)dimValue; 
    return JqLib.makeHexString(((Integer)dimValue).intValue());
  }
  
  public String getSQLFilter(String tablePrefix, Object dimValue) {
    return getSQLFilter(tablePrefix, dimValue, false);
  }
  
  public String getSQLFilter(String tablePrefix, Object dimValue, boolean isPrepared) {
    if (dimValue == null)
      return ""; 
    StringBuffer filter = new StringBuffer(64);
    filter.append('(');
    if (tablePrefix != null)
      filter.append(tablePrefix); 
    filter.append(this.fieldName);
    filter.append('=');
    if (isPrepared) {
      filter.append('?');
    } else if (this.isString) {
      filter.append('\'');
      filter.append((String)dimValue);
      filter.append('\'');
    } else if (dimValue instanceof Integer) {
      filter.append(((Integer)dimValue).intValue());
    } else {
      filter.append(dimValue.toString());
    } 
    filter.append(')');
    return filter.toString();
  }
  
  public int setParameter(PreparedStatement ps, Object value, int index) throws SQLException {
    if (ps == null || value == null || index <= 0)
      return index; 
    if (this.isString) {
      ps.setString(index, (String)value);
    } else if (value instanceof Integer) {
      ps.setInt(index, ((Integer)value).intValue());
    } else {
      ps.setString(index, value.toString());
    } 
    return index + 1;
  }
  
  public void appendInsertSql(StringBuffer fieldsBuffer, StringBuffer paramsBuffer) {
    fieldsBuffer.append(this.fieldName);
    fieldsBuffer.append(',');
    paramsBuffer.append("?,");
  }
  
  public void appendWhereClause(StringBuffer sqlBuffer) {
    sqlBuffer.append(this.fieldName);
    sqlBuffer.append("=? AND ");
  }
  
  public static final Integer DEFAULT_ORDER = new Integer(1);
  
  public static final com.jiuqi.mde.MDEDimension createOrderDimension() {
    return (com.jiuqi.mde.MDEDimension)new OrderDimension();
  }
  
  public static String MIN_STR_DIM_VALUE = "";
  
  public static String MAX_STR_DIM_VALUE = "￿￿￿￿￿￿￿￿";
  
  public static Integer MIN_INT_DIM_VALUE = new Integer(0);
  
  public static Integer MAX_INT_DIM_VALUE = new Integer(99999999);
}
